﻿// --------------------------------------------------------------------------------------
//
// CodeKarte.cs                                                   Ulrich Müller  26.06.07
//                                                                PCS1700 C# 2005 Express
// Codekartenleser mit automatischem Einzug aus "Experimentierbuch Profi Computing" 1991
// Warten auf Karte, Einzug um fünf Löcher links dabei festellen der Löcher rechts
// und Erstellen eines Dezimalwertes dafür. Der Wert wird am ACTION Ende angezeigt. 
// Die Karte wird wieder ausgeworfen.
// Basis ist die Assembly FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace CodeKarte {
  public partial class CodeKarte : Form {
    FishFace ft = new FishFace();

    private void Action() {
      ft.SetMotor(Out.M2, Dir.On);
      ft.SetMotor(Out.M3, Dir.On);
      lblStatus.Text = "Bitte Karte eingeben";
      ft.WaitForInput(Inp.I1, true);
      ft.SetMotor(Out.M1, Dir.Rechts);

      int CodeZahl = 0;
      int Zwei = 1;
      for (int i = 1; i <= 5; i++) {
        ft.WaitForHigh(Inp.I3);
        ft.Pause(22);
        if (ft.GetInput(Inp.I2)) CodeZahl += Zwei;
        Zwei *= 2;
      }
      
      ft.SetMotor(Out.M1, Dir.Left);
      ft.WaitForInput(Inp.I1, false);
      ft.SetMotor(Out.M1, Dir.Off);
      ft.SetMotor(Out.M2, Dir.Off);
      ft.SetMotor(Out.M3, Dir.Off);
      lblStatus.Text = "Zähler rechts : " + CodeZahl.ToString();
    }

    #region --- Programm-Kontrolle ---
    public CodeKarte() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        //lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}