﻿// --------------------------------------------------------------------------------------
//
// TresorKarte.cs                                                 Ulrich Müller  27.06.07
//                                                                PCS1700 C# 2005 Express
// Tresor mit Codekartenleser
// Basis ist die Assembly FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace TresorKarte {
  public partial class CodeKarte : Form {
    const int mTresor      = 1;
    const int mKarte       = 2;
    const int mLochL       = 3;
    const int mLochR       = 4;
    const int eKarteDrin   = 1;
    const int eLochDaR     = 2;
    const int eLochDaL     = 3;
    const int eTresorOffen = 5;
    const int eTresorZu    = 6;

    FishFace ft = new FishFace();

    private void Action() {
      do {
        ft.SetMotor(mLochL, (int)Dir.On);
        ft.SetMotor(mLochR, (int)Dir.On);
        ft.SetMotor(mTresor, (int)Dir.Right);
        ft.WaitForInput(eTresorZu);
        ft.SetMotor(mTresor, (int)Dir.Off);
        lblStatus.Text = "Bitte Karte eingeben";
        ft.WaitForInput(eKarteDrin, true);
        ft.SetMotor(mKarte, (int)Dir.Rechts);

        int CodeZahl = 0;
        int Zwei = 1;
        for (int i = 1; i <= 5; i++) {
          ft.WaitForHigh(eLochDaL);
          ft.Pause(16);
          if (ft.GetInput(eLochDaR)) CodeZahl += Zwei;
          Zwei *= 2;
        }
        
        ft.SetMotor(mKarte, (int)Dir.Left);
        ft.WaitForInput(eKarteDrin, false);
        ft.SetMotor(mLochL, (int)Dir.Off);
        ft.SetMotor(mLochR, (int)Dir.Off);
        ft.SetMotor(mKarte, (int)Dir.Off);
        lblStatus.Text = "Zähler rechts : " + CodeZahl.ToString();

        if (CodeZahl == 26) {
          ft.SetMotor(mTresor, (int)Dir.Left);
          ft.WaitForInput(eTresorOffen);
          ft.SetMotor(mTresor, (int)Dir.Off);
          ft.WaitForInput(eTresorZu);
          lblStatus.Text = "Tresor schließen : Taster I6";
          ft.SetMotor(mTresor, (int)Dir.Right);
          ft.WaitForHigh(eTresorZu);
          ft.SetMotor(mTresor, (int)Dir.Off);
        }
        else lblStatus.Text = "Da war wohl nichts";
      } while (!ft.Finish());
    }

    #region --- Programm-Kontrolle ---
    public CodeKarte() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      // --- Open erstes ROBO an USB oder Intelligent Interface an COM
      //     während des Ablaufs von Action() gesperrt ---------------
      try {
        if (cboPortName.SelectedIndex == 0)
          ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        else ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

        ft.ClearMotors();
      }
      catch (FishFaceException eft) {
        MessageBox.Show(eft.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        ft.CloseInterface();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
    }

    private void formLoad(object sender, EventArgs e) {
      // --- Default-Interface : Erstes ROBO Interface an USB ----
      cboPortName.SelectedIndex = 0;
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}